var EventEmitter = require("bindable").EventEmitter;

module.exports = function (app) {

  app.use(require("mojo-mediator"));

  var readyEmitter = new EventEmitter(),
  ready = false;

  readyEmitter.once("ready", function () {
    ready = true;
  });

  app.bootstrap = function (complete) {
    app.ready(complete);
    app.initialize();
  };

  app.ready = function (callback) {
    if (ready) return callback();
    readyEmitter.once("ready", callback);
  };

  app.once("initialize", function (options) {
    app.mediator.execute("bootstrap", options, function () {
      if (app.didBootstrap) {
        app.didBootstrap(options);
      }
      readyEmitter.emit("ready");
    });
  });

}